
//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  3
#property indicator_color1   clrLime
#property indicator_color2   clrRed
#property indicator_color3   clrDarkSlateGray
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2
#property strict

//
//
//
//
//

extern int  AdxPeriod = 14; // Adx period


double Up[],Dn[],adx[],trend[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);  
   SetIndexBuffer(0,Up);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dn);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,adx);
   SetIndexBuffer(3,trend);
return(0);
}
int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(Bars-counted_bars,Bars-1); 
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      adx[i] = iADX(NULL,0,AdxPeriod,PRICE_CLOSE,MODE_MAIN,   i);
      double adxplus  = iADX(NULL,0,AdxPeriod,PRICE_CLOSE,MODE_PLUSDI, i);
      double adxminus = iADX(NULL,0,AdxPeriod,PRICE_CLOSE,MODE_MINUSDI,i);
      trend[i] = (i<Bars-1) ? (adxplus>adxminus) ? 1 : (adxplus<adxminus) ? -1 : trend[i+1] : 0;  
      Up[i] = (trend[i] ==  1) ? adx[i] : EMPTY_VALUE;
      Dn[i] = (trend[i] == -1) ? adx[i] : EMPTY_VALUE;
   }
return(0);
}

